﻿Type=Class
Version=5.9
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Custom View class
#Event: TabChanged (Text As String,UserChanged As Boolean)
#DesignerProperty: Key: TabPos, DisplayName: Tab Position, FieldType: String, DefaultValue: TOP, List: TOP|BOTTOM
Sub Class_Globals
	Private fx As JFX
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As Pane
	Private FP As FlowPane
	Private SP As StackPane
	Private mRowHeight As Int = 30
	Private FPVGap As Int = 3
	Private FPHGap As Int = 1
	Private ToggleGrp As ToggleGroup
	Private BtnList As List
	Private PnList As List
	Private TabPos As String
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	ToggleGrp.Initialize
	BtnList.Initialize
	PnList.Initialize
End Sub

Public Sub DesignerCreateView (Base As Pane, Lbl As Label, Props As Map)
	mBase = Base
	FP.Initialize
	FP.Create2(FPHGap,FPVGap)
	FP.SetPrefWrapLength(mBase.PrefWidth)
	CSSUtils.SetBackgroundColor(FP.AsObject,fx.Colors.RGB(230,230,230))
	SP.Initialize
	SP.Create
	TabPos = Props.GetDefault("TabPos","TOP")
	If TabPos = "TOP" Then
		mBase.AddNode(FP.AsObject,0,0,mBase.PrefWidth,mRowHeight)
		mBase.AddNode(SP.AsObject,0,mRowHeight,mBase.PrefWidth,mBase.PrefHeight - mRowHeight)
	Else
		mBase.AddNode(FP.AsObject,0,mBase.PrefHeight - mRowHeight, mBase.PrefWidth, mRowHeight)
		mBase.AddNode(SP.AsObject,0,0,mBase.PrefWidth,mBase.PrefHeight - mRowHeight)
	End If
	
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	FP.AsNode.PrefWidth = Width
	FP.SetPrefWrapLength(Width)
	Sleep(0)
	Dim FPLayoutHeight As Double = Max(mRowHeight, FP.AsJavaObject.RunMethodJO("getLayoutBounds",Null).RunMethod("getHeight",Null))
	If TabPos = "TOP" Then
		SP.AsNode.Top = FPLayoutHeight
		SP.SetPrefWidth(Width)
		SP.SetPrefHeight(Height - FPLayoutHeight)
	Else
		SP.SetPrefWidth(Width)
		SP.SetPrefHeight(Height - FPLayoutHeight)
		FP.AsNode.Top = mBase.PrefHeight - FPLayoutHeight
	End If
End Sub

'Provide a name for the tab and a Pane with the layout already loaded.
Public Sub AddTab(Text As String, Pn As Pane)
	Dim B As ToggleButton
	B.Initialize("Btn")
	B.Tag = FP.GetChildren.Size
	B.Text = Text
	BtnList.Add(B)
	PnList.Add(Pn)
	ToggleGrp.GetToggles.Add(B)
	Pn.Tag = B.Tag
	CSSUtils.SetBackgroundColor(Pn,fx.Colors.White)
	FP.GetChildren.Add(B)
	SP.GetChildren.Add(Pn)
End Sub

Public Sub HideTab(Text As String)
	Dim L As List = FP.GetChildren
	Dim Found As Boolean
	For i = 0 To L.Size - 1
		Dim Tb As ToggleButton = L.Get(i)
		If Tb.Text = Text Then
			Found = True
			Exit
		End If
	Next
	If Found Then
		L.RemoveAt(i)
		Found = False
		Dim L As List = SP.GetChildren
		For i = 0 To L.Size - 1
			Dim Pn As Pane = L.Get(i)
			If Pn.Tag = Tb.Tag Then
				Found = True
				Exit
			End If
		Next
		If Found Then L.RemoveAt(i)
	End If
End Sub

Public Sub ShowTab(Text As String)
	Dim Found As Boolean
	For i = 0 To BtnList.Size - 1
		Dim Tb As ToggleButton = BtnList.Get(i)
		If Tb.Text = Text Then
			Found = True
			Exit
		End If
	Next
	If Found Then
		Dim L As List = FP.GetChildren
		L.InsertAt(i,BtnList.Get(i))
		L = PnList
		For i = 0 To L.Size - 1
			Dim Pn As Pane = L.Get(i)
			If Pn.Tag = Tb.Tag Then
				Found = True
				Exit
			End If
		Next
		If Found Then
			Dim L As List = SP.GetChildren
			L.InsertAt(0,Pn)
		End If
	End If
End Sub

Public Sub Size As Int
	Return BtnList.Size
End Sub

Public Sub GetBase As Pane
	Return mBase
End Sub

Private Sub Btn_Action
	Dim TB As ToggleButton = Sender
	Dim L As List = SP.GetChildren
	For i = 0 To L.Size - 1
		Dim N As Node = L.Get(i)
		If N.Tag = TB.Tag Then
			L.RemoveAt(i)
			L.Add(N)
			Exit
		End If
	Next
	If SubExists(mCallBack,mEventName & "_TabChanged") Then CallSubDelayed3(mCallBack,mEventName & "_TabChanged",TB.Text,True)
End Sub

Public Sub setSelectedIndex(Index As Int)
	Dim L As List = FP.GetChildren
	Dim TB As ToggleButton = L.Get(Index)
	
	Dim L As List = SP.GetChildren
	For i = 0 To L.Size - 1
		Dim N As Node = L.Get(i)
		If N.Tag = TB.Tag Then
			L.RemoveAt(i)
			L.Add(N)
			Exit
		End If
	Next
	TB.Selected = True
	TB.RequestFocus
	If SubExists(mCallBack,mEventName & "_TabChanged") Then CallSubDelayed3(mCallBack,mEventName & "_TabChanged",TB.Text,False)
End Sub

Public Sub getSelectedIndex As Int
	Dim L As List = SP.GetChildren
	Dim N As Node = L.Get(L.Size-1)
	Return N.Tag
End Sub

Public Sub SetEnabled(Text As String, Enabled As Boolean) As Boolean
	Dim L As List = FP.GetChildren
	For Each TB As ToggleButton In L
		If TB.Text = Text Then
			TB.Enabled = Enabled
			Return True
		End If
	Next
	Return False
End Sub
Public Sub GetEnabled(Text As String) As Boolean
	Dim L As List = FP.GetChildren
	For Each TB As ToggleButton In L
		If TB.Text = Text Then
			Return TB.Enabled
		End If
	Next
	Return False
End Sub

Public Sub FindIndex(Pn As Pane) As Int
	Dim FoundPos As Int = -1
'	Dim Pos As Int = SP.GetChildren.IndexOf(Pn)
	
'	If Pos > -1 Then
		Dim L As List = FP.GetChildren
		Dim Found As Boolean
		For i = 0 To L.Size - 1
			Dim TB As ToggleButton = L.Get(i)
			If TB.Tag = Pn.Tag Then
				Found = True
				Exit
			End If
		Next
		If Found Then FoundPos = i
'	End If

	Return FoundPos
End Sub
